/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 2;
using PredicateBitset = llvm::PredicateBitsetImpl<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ISelInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ISelInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const int64_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const std::array<const MachineOperand *, 3> &Operands) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ISelInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features;
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features;
  return Features;
}

// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
const static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

// PatFrag predicates.
enum {
  GIPFP_I64_Predicate_Mximm16_1to8 = GIPFP_I64_Invalid + 1,
  GIPFP_I64_Predicate_Mximm32_1to8,
  GIPFP_I64_Predicate_Mximm8_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GIPFP_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  case GIPFP_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  case GIPFP_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const std::array<const MachineOperand *, 3> &Operands) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  MachineFunction &MF = *I.getParent()->getParent();
  MachineRegisterInfo &MRI = MF.getRegInfo();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  NewMIVector OutMIs;
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, OutMIs, State, ISelInfo, getMatchTable(), TII, MRI, TRI, RBI, AvailableFeatures, CoverageInfo)) {
    return true;
  }

  return false;
}

const int64_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static int64_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/44, 120, /*)*//*default:*//*Label 15*/ 2346,
    /*TargetOpcode::G_ADD*//*Label 0*/ 81,
    /*TargetOpcode::G_SUB*//*Label 1*/ 265, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_AND*//*Label 2*/ 523,
    /*TargetOpcode::G_OR*//*Label 3*/ 707,
    /*TargetOpcode::G_XOR*//*Label 4*/ 891, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ANYEXT*//*Label 5*/ 1075,
    /*TargetOpcode::G_TRUNC*//*Label 6*/ 1125,
    /*TargetOpcode::G_CONSTANT*//*Label 7*/ 1163, 0, 0, 0,
    /*TargetOpcode::G_SEXT*//*Label 8*/ 1281, 0,
    /*TargetOpcode::G_ZEXT*//*Label 9*/ 1331,
    /*TargetOpcode::G_SHL*//*Label 10*/ 1381,
    /*TargetOpcode::G_LSHR*//*Label 11*/ 1574,
    /*TargetOpcode::G_ASHR*//*Label 12*/ 1767, 0, 0,
    /*TargetOpcode::G_ROTR*//*Label 13*/ 1960,
    /*TargetOpcode::G_ROTL*//*Label 14*/ 2153,
    // Label 0: @81
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 19*/ 264,
    /*GILLT_s8*//*Label 16*/ 90,
    /*GILLT_s16*//*Label 17*/ 148,
    /*GILLT_s32*//*Label 18*/ 206,
    // Label 16: @90
    GIM_Try, /*On fail goto*//*Label 20*/ 147,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 21*/ 134, // Rule ID 560 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 560,
        GIR_Done,
      // Label 21: @134
      GIM_Try, /*On fail goto*//*Label 22*/ 146, // Rule ID 548 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 548,
        GIR_Done,
      // Label 22: @146
      GIM_Reject,
    // Label 20: @147
    GIM_Reject,
    // Label 17: @148
    GIM_Try, /*On fail goto*//*Label 23*/ 205,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 24*/ 192, // Rule ID 561 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 561,
        GIR_Done,
      // Label 24: @192
      GIM_Try, /*On fail goto*//*Label 25*/ 204, // Rule ID 549 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 549,
        GIR_Done,
      // Label 25: @204
      GIM_Reject,
    // Label 23: @205
    GIM_Reject,
    // Label 18: @206
    GIM_Try, /*On fail goto*//*Label 26*/ 263,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 27*/ 250, // Rule ID 562 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32ri:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD32ri,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 562,
        GIR_Done,
      // Label 27: @250
      GIM_Try, /*On fail goto*//*Label 28*/ 262, // Rule ID 550 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32rr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxXRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD32rr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 550,
        GIR_Done,
      // Label 28: @262
      GIM_Reject,
    // Label 26: @263
    GIM_Reject,
    // Label 19: @264
    GIM_Reject,
    // Label 1: @265
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 32*/ 522,
    /*GILLT_s8*//*Label 29*/ 274,
    /*GILLT_s16*//*Label 30*/ 354,
    /*GILLT_s32*//*Label 31*/ 434,
    // Label 29: @274
    GIM_Try, /*On fail goto*//*Label 33*/ 353,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 34*/ 310, // Rule ID 412 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG8d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 412,
        GIR_Done,
      // Label 34: @310
      GIM_Try, /*On fail goto*//*Label 35*/ 340, // Rule ID 599 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 599,
        GIR_Done,
      // Label 35: @340
      GIM_Try, /*On fail goto*//*Label 36*/ 352, // Rule ID 587 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 587,
        GIR_Done,
      // Label 36: @352
      GIM_Reject,
    // Label 33: @353
    GIM_Reject,
    // Label 30: @354
    GIM_Try, /*On fail goto*//*Label 37*/ 433,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 38*/ 390, // Rule ID 414 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG16d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 414,
        GIR_Done,
      // Label 38: @390
      GIM_Try, /*On fail goto*//*Label 39*/ 420, // Rule ID 600 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 600,
        GIR_Done,
      // Label 39: @420
      GIM_Try, /*On fail goto*//*Label 40*/ 432, // Rule ID 588 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 588,
        GIR_Done,
      // Label 40: @432
      GIM_Reject,
    // Label 37: @433
    GIM_Reject,
    // Label 31: @434
    GIM_Try, /*On fail goto*//*Label 41*/ 521,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 42*/ 470, // Rule ID 416 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG32d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 416,
        GIR_Done,
      // Label 42: @470
      GIM_Try, /*On fail goto*//*Label 43*/ 504, // Rule ID 601 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32ri:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB32ri,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 601,
        GIR_Done,
      // Label 43: @504
      GIM_Try, /*On fail goto*//*Label 44*/ 520, // Rule ID 589 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32rr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxXRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB32rr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 589,
        GIR_Done,
      // Label 44: @520
      GIM_Reject,
    // Label 41: @521
    GIM_Reject,
    // Label 32: @522
    GIM_Reject,
    // Label 2: @523
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 48*/ 706,
    /*GILLT_s8*//*Label 45*/ 532,
    /*GILLT_s16*//*Label 46*/ 590,
    /*GILLT_s32*//*Label 47*/ 648,
    // Label 45: @532
    GIM_Try, /*On fail goto*//*Label 49*/ 589,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 50*/ 576, // Rule ID 629 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 629,
        GIR_Done,
      // Label 50: @576
      GIM_Try, /*On fail goto*//*Label 51*/ 588, // Rule ID 626 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 626,
        GIR_Done,
      // Label 51: @588
      GIM_Reject,
    // Label 49: @589
    GIM_Reject,
    // Label 46: @590
    GIM_Try, /*On fail goto*//*Label 52*/ 647,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 53*/ 634, // Rule ID 630 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 630,
        GIR_Done,
      // Label 53: @634
      GIM_Try, /*On fail goto*//*Label 54*/ 646, // Rule ID 627 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 627,
        GIR_Done,
      // Label 54: @646
      GIM_Reject,
    // Label 52: @647
    GIM_Reject,
    // Label 47: @648
    GIM_Try, /*On fail goto*//*Label 55*/ 705,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 56*/ 692, // Rule ID 631 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 631,
        GIR_Done,
      // Label 56: @692
      GIM_Try, /*On fail goto*//*Label 57*/ 704, // Rule ID 628 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 628,
        GIR_Done,
      // Label 57: @704
      GIM_Reject,
    // Label 55: @705
    GIM_Reject,
    // Label 48: @706
    GIM_Reject,
    // Label 3: @707
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 61*/ 890,
    /*GILLT_s8*//*Label 58*/ 716,
    /*GILLT_s16*//*Label 59*/ 774,
    /*GILLT_s32*//*Label 60*/ 832,
    // Label 58: @716
    GIM_Try, /*On fail goto*//*Label 62*/ 773,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 63*/ 760, // Rule ID 635 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 635,
        GIR_Done,
      // Label 63: @760
      GIM_Try, /*On fail goto*//*Label 64*/ 772, // Rule ID 632 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 632,
        GIR_Done,
      // Label 64: @772
      GIM_Reject,
    // Label 62: @773
    GIM_Reject,
    // Label 59: @774
    GIM_Try, /*On fail goto*//*Label 65*/ 831,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 66*/ 818, // Rule ID 636 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 636,
        GIR_Done,
      // Label 66: @818
      GIM_Try, /*On fail goto*//*Label 67*/ 830, // Rule ID 633 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 633,
        GIR_Done,
      // Label 67: @830
      GIM_Reject,
    // Label 65: @831
    GIM_Reject,
    // Label 60: @832
    GIM_Try, /*On fail goto*//*Label 68*/ 889,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 69*/ 876, // Rule ID 637 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 637,
        GIR_Done,
      // Label 69: @876
      GIM_Try, /*On fail goto*//*Label 70*/ 888, // Rule ID 634 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 634,
        GIR_Done,
      // Label 70: @888
      GIM_Reject,
    // Label 68: @889
    GIM_Reject,
    // Label 61: @890
    GIM_Reject,
    // Label 4: @891
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 74*/ 1074,
    /*GILLT_s8*//*Label 71*/ 900,
    /*GILLT_s16*//*Label 72*/ 958,
    /*GILLT_s32*//*Label 73*/ 1016,
    // Label 71: @900
    GIM_Try, /*On fail goto*//*Label 75*/ 957,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 76*/ 944, // Rule ID 641 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 641,
        GIR_Done,
      // Label 76: @944
      GIM_Try, /*On fail goto*//*Label 77*/ 956, // Rule ID 638 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 638,
        GIR_Done,
      // Label 77: @956
      GIM_Reject,
    // Label 75: @957
    GIM_Reject,
    // Label 72: @958
    GIM_Try, /*On fail goto*//*Label 78*/ 1015,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 79*/ 1002, // Rule ID 642 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 642,
        GIR_Done,
      // Label 79: @1002
      GIM_Try, /*On fail goto*//*Label 80*/ 1014, // Rule ID 639 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 639,
        GIR_Done,
      // Label 80: @1014
      GIM_Reject,
    // Label 78: @1015
    GIM_Reject,
    // Label 73: @1016
    GIM_Try, /*On fail goto*//*Label 81*/ 1073,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 82*/ 1060, // Rule ID 643 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 643,
        GIR_Done,
      // Label 82: @1060
      GIM_Try, /*On fail goto*//*Label 83*/ 1072, // Rule ID 640 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 640,
        GIR_Done,
      // Label 83: @1072
      GIM_Reject,
    // Label 81: @1073
    GIM_Reject,
    // Label 74: @1074
    GIM_Reject,
    // Label 5: @1075
    GIM_Try, /*On fail goto*//*Label 84*/ 1124,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 87*/ 1123,
      /*GILLT_s8*//*Label 85*/ 1089,
      /*GILLT_s16*//*Label 86*/ 1106,
      // Label 85: @1089
      GIM_Try, /*On fail goto*//*Label 88*/ 1105, // Rule ID 509 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 509,
        GIR_Done,
      // Label 88: @1105
      GIM_Reject,
      // Label 86: @1106
      GIM_Try, /*On fail goto*//*Label 89*/ 1122, // Rule ID 513 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 513,
        GIR_Done,
      // Label 89: @1122
      GIM_Reject,
      // Label 87: @1123
      GIM_Reject,
    // Label 84: @1124
    GIM_Reject,
    // Label 6: @1125
    GIM_Try, /*On fail goto*//*Label 90*/ 1162, // Rule ID 517 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/TargetOpcode::COPY,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/2, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, M68k::XR16RegClassID,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, M68k::XR32RegClassID,
      // GIR_Coverage, 517,
      GIR_Done,
    // Label 90: @1162
    GIM_Reject,
    // Label 7: @1163
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 94*/ 1280,
    /*GILLT_s8*//*Label 91*/ 1172,
    /*GILLT_s16*//*Label 92*/ 1194,
    /*GILLT_s32*//*Label 93*/ 1237,
    // Label 91: @1172
    GIM_Try, /*On fail goto*//*Label 95*/ 1193, // Rule ID 6 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOV8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV8di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 6,
      GIR_Done,
    // Label 95: @1193
    GIM_Reject,
    // Label 92: @1194
    GIM_Try, /*On fail goto*//*Label 96*/ 1215, // Rule ID 13 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 13,
      GIR_Done,
    // Label 96: @1215
    GIM_Try, /*On fail goto*//*Label 97*/ 1236, // Rule ID 20 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ai:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 20,
      GIR_Done,
    // Label 97: @1236
    GIM_Reject,
    // Label 93: @1237
    GIM_Try, /*On fail goto*//*Label 98*/ 1258, // Rule ID 27 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 27,
      GIR_Done,
    // Label 98: @1258
    GIM_Try, /*On fail goto*//*Label 99*/ 1279, // Rule ID 34 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ai:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 34,
      GIR_Done,
    // Label 99: @1279
    GIM_Reject,
    // Label 94: @1280
    GIM_Reject,
    // Label 8: @1281
    GIM_Try, /*On fail goto*//*Label 100*/ 1330,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 103*/ 1329,
      /*GILLT_s8*//*Label 101*/ 1295,
      /*GILLT_s16*//*Label 102*/ 1312,
      // Label 101: @1295
      GIM_Try, /*On fail goto*//*Label 104*/ 1311, // Rule ID 485 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 485,
        GIR_Done,
      // Label 104: @1311
      GIM_Reject,
      // Label 102: @1312
      GIM_Try, /*On fail goto*//*Label 105*/ 1328, // Rule ID 489 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 489,
        GIR_Done,
      // Label 105: @1328
      GIM_Reject,
      // Label 103: @1329
      GIM_Reject,
    // Label 100: @1330
    GIM_Reject,
    // Label 9: @1331
    GIM_Try, /*On fail goto*//*Label 106*/ 1380,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 109*/ 1379,
      /*GILLT_s8*//*Label 107*/ 1345,
      /*GILLT_s16*//*Label 108*/ 1362,
      // Label 107: @1345
      GIM_Try, /*On fail goto*//*Label 110*/ 1361, // Rule ID 497 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 497,
        GIR_Done,
      // Label 110: @1361
      GIM_Reject,
      // Label 108: @1362
      GIM_Try, /*On fail goto*//*Label 111*/ 1378, // Rule ID 501 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 501,
        GIR_Done,
      // Label 111: @1378
      GIM_Reject,
      // Label 109: @1379
      GIM_Reject,
    // Label 106: @1380
    GIM_Reject,
    // Label 10: @1381
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 115*/ 1573,
    /*GILLT_s8*//*Label 112*/ 1390,
    /*GILLT_s16*//*Label 113*/ 1451,
    /*GILLT_s32*//*Label 114*/ 1512,
    // Label 112: @1390
    GIM_Try, /*On fail goto*//*Label 116*/ 1450,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 117*/ 1437, // Rule ID 238 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 238,
        GIR_Done,
      // Label 117: @1437
      GIM_Try, /*On fail goto*//*Label 118*/ 1449, // Rule ID 235 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 235,
        GIR_Done,
      // Label 118: @1449
      GIM_Reject,
    // Label 116: @1450
    GIM_Reject,
    // Label 113: @1451
    GIM_Try, /*On fail goto*//*Label 119*/ 1511,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 120*/ 1498, // Rule ID 239 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 239,
        GIR_Done,
      // Label 120: @1498
      GIM_Try, /*On fail goto*//*Label 121*/ 1510, // Rule ID 236 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 236,
        GIR_Done,
      // Label 121: @1510
      GIM_Reject,
    // Label 119: @1511
    GIM_Reject,
    // Label 114: @1512
    GIM_Try, /*On fail goto*//*Label 122*/ 1572,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 123*/ 1559, // Rule ID 240 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 240,
        GIR_Done,
      // Label 123: @1559
      GIM_Try, /*On fail goto*//*Label 124*/ 1571, // Rule ID 237 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 237,
        GIR_Done,
      // Label 124: @1571
      GIM_Reject,
    // Label 122: @1572
    GIM_Reject,
    // Label 115: @1573
    GIM_Reject,
    // Label 11: @1574
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 128*/ 1766,
    /*GILLT_s8*//*Label 125*/ 1583,
    /*GILLT_s16*//*Label 126*/ 1644,
    /*GILLT_s32*//*Label 127*/ 1705,
    // Label 125: @1583
    GIM_Try, /*On fail goto*//*Label 129*/ 1643,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 130*/ 1630, // Rule ID 244 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 244,
        GIR_Done,
      // Label 130: @1630
      GIM_Try, /*On fail goto*//*Label 131*/ 1642, // Rule ID 241 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 241,
        GIR_Done,
      // Label 131: @1642
      GIM_Reject,
    // Label 129: @1643
    GIM_Reject,
    // Label 126: @1644
    GIM_Try, /*On fail goto*//*Label 132*/ 1704,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 133*/ 1691, // Rule ID 245 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 245,
        GIR_Done,
      // Label 133: @1691
      GIM_Try, /*On fail goto*//*Label 134*/ 1703, // Rule ID 242 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 242,
        GIR_Done,
      // Label 134: @1703
      GIM_Reject,
    // Label 132: @1704
    GIM_Reject,
    // Label 127: @1705
    GIM_Try, /*On fail goto*//*Label 135*/ 1765,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 136*/ 1752, // Rule ID 246 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 246,
        GIR_Done,
      // Label 136: @1752
      GIM_Try, /*On fail goto*//*Label 137*/ 1764, // Rule ID 243 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 243,
        GIR_Done,
      // Label 137: @1764
      GIM_Reject,
    // Label 135: @1765
    GIM_Reject,
    // Label 128: @1766
    GIM_Reject,
    // Label 12: @1767
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 141*/ 1959,
    /*GILLT_s8*//*Label 138*/ 1776,
    /*GILLT_s16*//*Label 139*/ 1837,
    /*GILLT_s32*//*Label 140*/ 1898,
    // Label 138: @1776
    GIM_Try, /*On fail goto*//*Label 142*/ 1836,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 143*/ 1823, // Rule ID 250 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 250,
        GIR_Done,
      // Label 143: @1823
      GIM_Try, /*On fail goto*//*Label 144*/ 1835, // Rule ID 247 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 247,
        GIR_Done,
      // Label 144: @1835
      GIM_Reject,
    // Label 142: @1836
    GIM_Reject,
    // Label 139: @1837
    GIM_Try, /*On fail goto*//*Label 145*/ 1897,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 146*/ 1884, // Rule ID 251 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 251,
        GIR_Done,
      // Label 146: @1884
      GIM_Try, /*On fail goto*//*Label 147*/ 1896, // Rule ID 248 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 248,
        GIR_Done,
      // Label 147: @1896
      GIM_Reject,
    // Label 145: @1897
    GIM_Reject,
    // Label 140: @1898
    GIM_Try, /*On fail goto*//*Label 148*/ 1958,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 149*/ 1945, // Rule ID 252 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 252,
        GIR_Done,
      // Label 149: @1945
      GIM_Try, /*On fail goto*//*Label 150*/ 1957, // Rule ID 249 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 249,
        GIR_Done,
      // Label 150: @1957
      GIM_Reject,
    // Label 148: @1958
    GIM_Reject,
    // Label 141: @1959
    GIM_Reject,
    // Label 13: @1960
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 154*/ 2152,
    /*GILLT_s8*//*Label 151*/ 1969,
    /*GILLT_s16*//*Label 152*/ 2030,
    /*GILLT_s32*//*Label 153*/ 2091,
    // Label 151: @1969
    GIM_Try, /*On fail goto*//*Label 155*/ 2029,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 156*/ 2016, // Rule ID 262 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 262,
        GIR_Done,
      // Label 156: @2016
      GIM_Try, /*On fail goto*//*Label 157*/ 2028, // Rule ID 259 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 259,
        GIR_Done,
      // Label 157: @2028
      GIM_Reject,
    // Label 155: @2029
    GIM_Reject,
    // Label 152: @2030
    GIM_Try, /*On fail goto*//*Label 158*/ 2090,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 159*/ 2077, // Rule ID 263 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 263,
        GIR_Done,
      // Label 159: @2077
      GIM_Try, /*On fail goto*//*Label 160*/ 2089, // Rule ID 260 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 260,
        GIR_Done,
      // Label 160: @2089
      GIM_Reject,
    // Label 158: @2090
    GIM_Reject,
    // Label 153: @2091
    GIM_Try, /*On fail goto*//*Label 161*/ 2151,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 162*/ 2138, // Rule ID 264 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 264,
        GIR_Done,
      // Label 162: @2138
      GIM_Try, /*On fail goto*//*Label 163*/ 2150, // Rule ID 261 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 261,
        GIR_Done,
      // Label 163: @2150
      GIM_Reject,
    // Label 161: @2151
    GIM_Reject,
    // Label 154: @2152
    GIM_Reject,
    // Label 14: @2153
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 167*/ 2345,
    /*GILLT_s8*//*Label 164*/ 2162,
    /*GILLT_s16*//*Label 165*/ 2223,
    /*GILLT_s32*//*Label 166*/ 2284,
    // Label 164: @2162
    GIM_Try, /*On fail goto*//*Label 168*/ 2222,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 169*/ 2209, // Rule ID 256 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 256,
        GIR_Done,
      // Label 169: @2209
      GIM_Try, /*On fail goto*//*Label 170*/ 2221, // Rule ID 253 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 253,
        GIR_Done,
      // Label 170: @2221
      GIM_Reject,
    // Label 168: @2222
    GIM_Reject,
    // Label 165: @2223
    GIM_Try, /*On fail goto*//*Label 171*/ 2283,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 172*/ 2270, // Rule ID 257 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 257,
        GIR_Done,
      // Label 172: @2270
      GIM_Try, /*On fail goto*//*Label 173*/ 2282, // Rule ID 254 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 254,
        GIR_Done,
      // Label 173: @2282
      GIM_Reject,
    // Label 171: @2283
    GIM_Reject,
    // Label 166: @2284
    GIM_Try, /*On fail goto*//*Label 174*/ 2344,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 175*/ 2331, // Rule ID 258 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 258,
        GIR_Done,
      // Label 175: @2331
      GIM_Try, /*On fail goto*//*Label 176*/ 2343, // Rule ID 255 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 255,
        GIR_Done,
      // Label 176: @2343
      GIM_Reject,
    // Label 174: @2344
    GIM_Reject,
    // Label 167: @2345
    GIM_Reject,
    // Label 15: @2346
    GIM_Reject,
    };
  return MatchTable0;
}
#endif // ifdef GET_GLOBALISEL_IMPL
#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
